unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, StdCtrls, Grids, ValEdit, XPMan, ComCtrls, KDrop,
  Menus, Clipbrd, FileCtrl;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ValueListEditor1: TValueListEditor;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ProgressBar1: TProgressBar;
    KAddDrop1: TKAddDrop;
    PopupMenu1: TPopupMenu;
    C1: TMenuItem;
    A1: TMenuItem;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    DriveComboBox1: TDriveComboBox;
    Edit1: TEdit;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
      DropFiles: TStrings);
    procedure A1Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FileListBox1DblClick(Sender: TObject);
  private
    { Private 錾 }
    procedure SelectedFile(FileName:String);
  public
    { Public 錾 }
  end;

  TCountProc = function (Max,Position:Integer):Boolean;

var
  Form1: TForm1;

const
  FileName : String = '';
  bfCount : Integer = 0;

implementation

{$R *.dfm}

// JEgR[obN
function CountUp(Max,Position:Integer):Boolean;
var
      multiply : Double;
      thCount : Integer;
begin
      Result := true;

      multiply := 100 / Max;
      thCount := Round(Position * multiply);

      if thCount <> bfCount then
      begin
            Application.ProcessMessages;
            Form1.ProgressBar1.Max := 100;
            Form1.ProgressBar1.Position := thCount;
            bfCount := thCount;
      end;
end;

// ʃoCgƏʃoCgւ
function ReverseBytes(wInt:Word):Word;
var
      Hi,Lo : Word;
begin
      Hi := (wInt and $00FF) shl 8;
      Lo := (wInt and $FF00) shr 8;

      Result := Hi or Lo;
end;

// JPEG
function AnalyzeJPEG(FileName:String;Info:TStrings;Counter:TCountProc):Word;
const
      // 僊Xg
      aUnits : Array [0..2] of String = ('Ȃ','dot per inch','dot per cm');
      aSamplings : Array [0..3] of String = ('?','O[XP[','?','tJ[');
var
      Stream : TFileStream;
      wBuf : Word;
      bBuf : Byte;
      i : Integer;
      SOI : Boolean;
      JFIF : Array [0..4] of Char;
      wSeglen : Word;
      dwSegOffset : Cardinal;
      bVersionA : Byte;
      bVersionB : Byte;
      bUnit : Byte;
      wXDensity : Word;
      wYDensity : Word;
      bXthumb : Byte;
      bYthumb : Byte;
      bSample : Byte;
      wXSize : Word;
      wYSize : Word;
      bSampling : Byte;
      JPEGType : SmallInt;
      Worked : Boolean;
      DataFlag : Boolean;
      CompLen : Cardinal;
begin
      SOI := false;
      JPEGType := -1;

      Stream := TFileStream.Create(FileName,fmOpenRead);
      try
            // SOI܂ŃV[N
            while (Stream.Position < Stream.Size) do
            begin
                  Stream.Read(wBuf,sizeof(wBuf));
                  if wBuf = $D8FF then
                  begin
                        SOI := true;
                        break;
                  end;

                  if Assigned(Counter) then
                  begin
                        if not Counter(Stream.Size,Stream.Position) then exit;
                  end;
            end;

            // SOI
            if SOI then
            begin
                  while (Stream.Position < Stream.Size) do
                  begin
                        wBuf := 0;
                        Stream.Read(wBuf,sizeof(wBuf));

                        Worked := false;
                        if (wbuf and $00FF) = $FF then
                        begin
                              // ZOg̒
                              Stream.Read(wSeglen,sizeof(wSeglen));
                              wSeglen := ReverseBytes(wSeglen);

                              // ZOg̃ItZbg
                              dwSegOffset := Stream.Position-sizeof(wSeglen);

                              // V[PVŃSSׂ
                              case (wbuf shr 8) of
                                    $E0 : { JFIF Header }
                                    begin
                                          Stream.Read(JFIF,sizeof(JFIF));
                                                Info.Values['JFIFwb_['] := JFIF;
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(bVersionA,sizeof(bVersionA));
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(bVersionB,sizeof(bVersionB));
                                                Info.Values['JPEGo[W'] := Format('%d.%.02d',[bVersionA,bVersionB]);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(bUnit,sizeof(bUnit));
                                                Info.Values['P'] := aUnits[bUnit];
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(wXDensity,sizeof(wXDensity));
                                                wXDensity := ReverseBytes(wXDensity);
                                                Info.Values['𑜓x'] := InttoStr(wXDensity);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(wYDensity,sizeof(wYDensity));
                                                wYDensity := ReverseBytes(wYDensity);
                                                Info.Values['𑜓x'] := InttoStr(wXDensity);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(bXthumb,sizeof(bXthumb));
                                                Info.Values['TlCsNZ()'] := InttoStr(bXthumb);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(bYthumb,sizeof(bYthumb));
                                                Info.Values['TlCsNZ()'] := InttoStr(bYthumb);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;

                                          Stream.Seek(wSeglen-(Stream.Position-dwSegOffset),soFromCurrent);
                                          Worked := true;
                                    end;

                                    $C0,$C2 : { SOF Type Header }
                                    begin
                                          JPEGType := 0;
                                          case (wbuf shr 8) of
                                                $C2 : JPEGType := 2;
                                          end;

                                          Stream.Read(bSample,sizeof(bSample));
                                                Info.Values['Tvx'] := InttoStr(bSample);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(wYSize,sizeof(wYSize));
                                                wYSize := ReverseBytes(wYSize);
                                                Info.Values['csNZ'] := InttoStr(wYSize);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(wXSize,sizeof(wXSize));
                                                wXSize := ReverseBytes(wXSize);
                                                Info.Values['sNZ'] := InttoStr(wXSize);
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;
                                          Stream.Read(bSampling,sizeof(bSampling));
                                                Info.Values['TvO'] := aSamplings[bSampling];
                                                if Stream.Position-dwSegOffset >= wSeglen then continue;

                                          Stream.Seek(wSeglen-(Stream.Position-dwSegOffset),soFromCurrent);
                                          Worked := true;
                                    end;

                                    $DA : { Start of Scan }
                                    begin
                                          Stream.Seek(wSeglen,soFromCurrent);
                                          DataFlag := true;

                                          //DataFlag := false;
                                          CompLen := 0;

                                          while (Stream.Position < Stream.Size) do
                                          begin
                                                Stream.Read(bBuf,sizeof(bBuf));


                                                if bBuf = $FF then
                                                begin
                                                      Stream.Read(bBuf,sizeof(bBuf));
                                                      if bBuf = $D9 then
                                                      begin
                                                            DataFlag := false;
                                                            Inc(CompLen,2);
                                                            break;
                                                      end;

                                                      Stream.Seek(-1,soFromCurrent);
                                                end;
                                                if DataFlag then Inc(CompLen);

                                                //if bBuf = $FF then DataFlag := true;
                                          end;

                                          Info.Values['C[Wf[^(EOI)'] := InttoStr(CompLen);
                                    end;
                              end;
                        end else
                        begin
                              // Seek for each byte
                              if Stream.Position<>Stream.Size then Stream.Seek(-1,soFromCurrent);
                        end;

                        if Assigned(Counter) then
                        begin
                              if not Counter(Stream.Size,Stream.Position) then exit;
                        end;
                  end;
            end;

            Result := JPEGType;
      finally
            Stream.Free;
      end;
end;

procedure TForm1.SelectedFile(FileName:String);
var
      buf : TStringList;
      r : Integer;
      tmp : Char;
begin
      buf := TStringList.Create;
      try
            Image1.Picture := nil;
            tmp := #13;
            Edit1.Text := ExtractFileDir(FileName);
            Edit1KeyPress(nil,tmp);

            r := AnalyzeJPEG(FileName,buf,CountUp);

            // 
            case r of
                  0 : Label3.Caption := 'ʓIJPEGł(SOF0,0xC0)';
                  2 : Label3.Caption := 'vObVuJPEGł(SOF2,0xC2)';
            else
                  Label3.Caption := 'sJPEGł(SOF NotFound)';
            end;

            // Fݒ
            case r of
                  0 : Label3.Font.Color := clWindowText;
                  2 : Label3.Font.Color := $00000090;
            else
                  Label3.Font.Color := $00A00000;
            end;

            Image1.Picture.LoadFromFile(FileName);
            ValueListEditor1.Strings.Assign(buf);
      finally
            buf.Free;
      end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
      if OpenDialog1.Execute then
      begin
            FileName := OpenDialog1.FileName;
            SelectedFile(FileName);
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
      ShowMessage('0x'+InttoHex(ReverseBytes($01FF),4));
end;

procedure TForm1.KAddDrop1DropFiles(Sender: TObject; Target: TWinControl;
  DropFiles: TStrings);
begin
      SelectedFile(DropFiles[0]);
end;

procedure TForm1.A1Click(Sender: TObject);
var
      Tmp : TGridRect;
begin
      Tmp := ValueListEditor1.Selection;
      Tmp.Top := 1;
      Tmp.Bottom := ValueListEditor1.RowCount-1;
      ValueListEditor1.Selection := Tmp;
end;

procedure TForm1.C1Click(Sender: TObject);
var
      i : Integer;
      line : String;
      buf : TStringList;
begin
      buf := TStringList.Create;
      buf.Delimiter := #$09;
      try
            line := 'Key' + #$09 + 'Value';
            buf.Add(line);

            for i := ValueListEditor1.Selection.Top to ValueListEditor1.Selection.Bottom do
            begin
                  line := ValueListEditor1.Cells[0,i] + #$09 + ValueListEditor1.Cells[1,i];
                  buf.Add(line);
            end;

            Clipboard.AsText := buf.Text;
      finally
            buf.Free;
      end;
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
      Edit1.Text := DirectoryListBox1.Directory;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
      DirectoryListBox1Change(nil);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
      if key = #13 then
      begin
            DirectoryListBox1.Directory := Edit1.Text;
      end;
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
      SelectedFile(FileListBox1.FileName);
end;

end.
